"use strict";

require("core-js/modules/web.dom-collections.iterator.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.counterAppreciationMessage = exports.ShareOnSocial = exports.CounterPopup = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Constants = require("./Constants");

var _functions = require("./functions");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/* eslint-disable default-case */
// import { useAuth, useUserData, useViewInterface } from "../../hooks";
// import { useAuth } from "../../hooks";
const counterAppreciationMessage = (type, handleSignin, loggedIn) => type === "global" ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, "This is the power of the many!", " ", /*#__PURE__*/_react.default.createElement("a", {
  href: _Constants.COMMUNITY_DISCORD_LINK,
  target: "_blank",
  className: "counterAppreciationMessage",
  rel: "noopener noreferrer"
}, "Join"), " ", "our discord to engage with our community.") : /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, loggedIn ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, "Your tabs make a difference Thank you for opening tabs with purpose.") : /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, "Small actions add up.", " ", /*#__PURE__*/_react.default.createElement("span", {
  className: "counterAppreciationMessage",
  onClick: handleSignin
}, "Sign in"), " ", "to keep track of your impact across devices"));

exports.counterAppreciationMessage = counterAppreciationMessage;

const Heading = _ref => {
  let {
    type,
    handleSignin,
    loggedIn
  } = _ref;
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "pb-6"
  }, /*#__PURE__*/_react.default.createElement("p", {
    className: "text popup-text-colour"
  }, counterAppreciationMessage(type, handleSignin, loggedIn)));
};

const Statistic = _ref2 => {
  let {
    title,
    image,
    value
  } = _ref2;
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "pt-14"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "flex-container"
  }, image, /*#__PURE__*/_react.default.createElement("p", {
    className: "numbers-heading"
  }, value ? (0, _functions.addCommas)(value) : value)), /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("p", {
    className: "text counter-popup-text"
  }, title)), /*#__PURE__*/_react.default.createElement("hr", {
    className: "grey-horizontal"
  }));
};

const Statistics = _ref3 => {
  let {
    dataList
  } = _ref3;
  return dataList.map((element, index) => {
    if (element.title === "Tons of CO2 eq. you have stored" && element.value === String(0)) return null;
    return /*#__PURE__*/_react.default.createElement(Statistic, {
      title: element.title,
      image: element.image,
      value: element.value,
      key: index
    });
  });
};

const ShareYourImpact = _ref4 => {
  let {
    type
  } = _ref4;
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "flex-container-space mt-16"
  }, /*#__PURE__*/_react.default.createElement("p", {
    className: "text-small primary-text-colour fw-600"
  }, "Share your impact"), /*#__PURE__*/_react.default.createElement(ShareOnSocial, {
    type: type
  }));
}; // TODO: Set dispatch for trees saved, current badge


const getIndividualPropertyName = socialHandle => {
  switch (socialHandle) {
    case "Facebook":
      return _Constants.EventPropertyInviteSentPersonalCounterFacebook;

    case "Twitter":
      return _Constants.EventPropertyInviteSentPersonalCounterTwitter;

    case "LinkedIn":
      return _Constants.EventPropertyInviteSentPersonalCounterLinkedIn;

    case "Messenger":
      return _Constants.EventPropertyInviteSentPersonalCounterMessenger;

    case "WhatsApp":
      return _Constants.EventPropertyInviteSentPersonalCounterWhatsApp;
  }
};

const getGlobalPropertyName = socialHandle => {
  switch (socialHandle) {
    case "Facebook":
      return _Constants.EventPropertyInviteSentUniversalCounterFacebook;

    case "Twitter":
      return _Constants.EventPropertyInviteSentUniversalCounterTwitter;

    case "LinkedIn":
      return _Constants.EventPropertyInviteSentUniversalCounterLinkedIn;

    case "Messenger":
      return _Constants.EventPropertyInviteSentUniversalCounterMessenger;

    case "WhatsApp":
      return _Constants.EventPropertyInviteSentUniversalCounterWhatsApp;
  }
};

const ShareOnSocial = _ref5 => {
  let {
    link: badgeLink,
    type,
    badgeName,
    numberOfTreesSaved,
    showCopyButton,
    eventProperty
  } = _ref5;
  const id = "12345",
        treesSaved = 43428782;
  const formattedTreesSaved = (0, _functions.addCommas)((0, _functions.NumberFloor)(treesSaved));
  let INVITE_MESSAGE, TWITTER_INVITE_MESSAGE, link;
  INVITE_MESSAGE = type === "achievement" || type === "achievement_notification" ? "I've achieved the ".concat(badgeName, " Badge for saving ").concat(numberOfTreesSaved, " trees with OpenTabs, a browser extension that saves a tree for every 10 tabs you open. It's an easy (and free) way to help the environment! \uD83C\uDF33\u2728") : "Hi there \uD83D\uDE0A I've saved ".concat(formattedTreesSaved, " trees with OpenTabs, and I think you should too! It's a browser extension that saves a tree for every 10 tabs you open, so it's an easy (and free) way to help the environment. Give it a try, they're currently saving 10 trees for every new person that joins: ");
  TWITTER_INVITE_MESSAGE = type === "achievement" || type === "achievement_notification" ? INVITE_MESSAGE : "I've saved ".concat(formattedTreesSaved, " trees with OpenTabs! It's a browser extension that saves a tree for every 10 tabs you open, so it's an easy (and free) way to help the environment. Give it a try, they're currently saving 10 trees for every new person that joins:");
  link = type === "achievement" || type === "achievement_notification" ? badgeLink : "".concat(_Constants.REFERRAL_LINK_HEADER).concat(id, "/");
  const buttonRef = (0, _react.useRef)(null);

  const copyButtonClickHandler = () => {
    (0, _functions.copyValueToClipboard)(link);
    buttonRef.current.querySelector("span").innerText = "Copied";
  };

  const getSharingLink = socialHandle => {
    switch (socialHandle) {
      case "Facebook":
        {
          return "https://www.facebook.com/sharer.php?u=".concat(link);
        }

      case "Twitter":
        {
          return "http://twitter.com/share?text=".concat(TWITTER_INVITE_MESSAGE, "&url=").concat(link);
        }

      case "LinkedIn":
        {
          return "https://www.linkedin.com/sharing/share-offsite/?url=".concat(link);
        }

      case "Messenger":
        {
          return "https://www.messenger.com/t/";
        }

      case "WhatsApp":
        {
          return "https://web.whatsapp.com/send?text=".concat(INVITE_MESSAGE, " ").concat(link);
        }

      default:
        {
          return link;
        }
    }
  };

  const socialInviteHandler = socialHandle => {
    const eventProperty = (type => {
      switch (type) {
        case "individual":
          return getIndividualPropertyName(socialHandle);

        case "global":
          return getGlobalPropertyName(socialHandle);
      }
    })(type);
  };

  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, _Constants.socialHandles.map((element, index) => /*#__PURE__*/_react.default.createElement("a", {
    href: getSharingLink(element.name),
    target: "_blank",
    rel: "noopener noreferrer",
    key: index,
    onClick: () => socialInviteHandler(element.name)
  }, /*#__PURE__*/_react.default.createElement("span", {
    key: index
  }, element.image))), showCopyButton === true && /*#__PURE__*/_react.default.createElement("button", {
    className: "button small-button button-primary image-button",
    onClick: copyButtonClickHandler,
    ref: buttonRef
  }, _Constants.copy, /*#__PURE__*/_react.default.createElement("span", null, "Copy")));
};

exports.ShareOnSocial = ShareOnSocial;

const CounterPopup = props => {
  //   const { settingsRef, toggleWidgetPopup } = useViewInterface();
  //   const { storageUserProfile, setStorageUserData } = useAuth();
  const loggedIn = false;

  const handleSignin = () => {};

  return /*#__PURE__*/_react.default.createElement("div", {
    className: "app counter-popup"
  }, /*#__PURE__*/_react.default.createElement(Heading, {
    type: props.type,
    handleSignin: handleSignin,
    loggedIn: loggedIn
  }), /*#__PURE__*/_react.default.createElement(Statistics, {
    dataList: props.dataList
  }), /*#__PURE__*/_react.default.createElement(ShareYourImpact, {
    type: props.type
  }));
};

exports.CounterPopup = CounterPopup;